/*	Beispielprogramm, welches die Benutzung von EasyGEM
	in Verbindung mit Extended Objecttypen und
	Userdefined Objects demonstriert.
	Autor: D. Rabich
	Datum: 3.Juli 1990 / 2.November 1990
	Entwickelt mit Turbo C 2.0 von Borland. */

#include "easygem.h"	/* Headerdatei von EasyGEM */
#include "demo3.h"		/* Indizes der Resourcen */

BYTE   rsrc_name[] = "DEMO3.RSC"	/* Name der RSC-Datei */
OBJECT *demodial;			/* Pointer auf Objektbaum */

WORD apl_id;				/* Application-ID */

MLOCAL USRBLK user_line,
              user_rrect,
              user_select;	/* Userblocks */

WORD v_handle;				/* Handle der VDI-Workstation */

/* Prototypen */
MLOCAL WORD cdecl ulinie (PARMBLK *parmblock);
MLOCAL WORD cdecl uselbutton (PARMBLK *parmblock);
MLOCAL WORD cdecl urrect (PARMBLK *parmblock);

MLOCAL VOID tune_dial (OBJECT *dial, WORD obj);
WORD main (VOID);

/* Einfache Linie */
MLOCAL WORD cdecl uline (PARMBLK *parmblock)
{
	WORD xy[4], xyclip[4];

	/* Clipping */
	xyclip[0] = parmblock->pb_xc;
	xyclip[1] = parmblock->pb_yc;
	xyclip[2] = parmblock->pb_xc + parmblock->pb_wc - 1;
	xyclip[3] = parmblock->pb_yc + parmblock->pb_hc - 1;

	vs_clip (v_handle, 1, xyclip);

	/* Objekt zeichnen */
	xy[0] = parmblock->pb_x;
	xy[1] = parmblock->pb_y + 1;
	xy[2] = parmblock->pb_x + parmblock->pb_w - 1;
	xy[3] = parmblock->pb_y + 1;
	v_pline (v_handle, 2, xy);

	vs_clip (v_handle, 0, xyclip);

	return (parmblock->pb_currstate);
}

/* Ankreuzbutton */
MLOCAL WORD cdecl uselbutton (PARMBLK *parmblk)
{
	WORD xy[8], xyclip[4];

	/* Clipping */
	xyclip[0] = parmblock->pb_xc;
	xyclip[1] = parmblock->pb_yc;
	xyclip[2] = parmblock->pb_xc + parmblock->pb_wc - 1;
	xyclip[3] = parmblock->pb_yc + parmblock->pb_hc - 1;

	vs_clip (v_handle, 1, xyclip);

	/* Objekt zeichnen */
	xy[0] = parmblock->pb_x + 1;
	xy[1] = parmblock->pb_y + 1;
	xy[2] = parmblock->pb_x + parmblock->pb_w - 2;
	xy[3] = parmblock->pb_y + parmblock->pb_h - 2;
	vsf_interior (v_handle, FIS_HOLLOW);
	v_bar (v_handle, xy);

	/* Selected? */
	if (parmblock->pb_currstate & SELECTED)
	{
		xy[6] = xy[0];
		xy[5] = xy[1];
		xy[4] = xy[2];
		xy[7] = xy[3];
		v_pline (v_handle, xy);
		v_pline (v_handle, &xy[4]);
	}

	vs_clip (v_handle, 0, xyclip);

	/* SELECTED wird selbst verwaltet, Rest weiter */

	return (parmblock->pb_currstate & ~SELECTED);
}

/* Rechteck mit abgerundeten Ecken */
MLOCAL WORD cdecl urrect (PARMBLK *parmblock);
{
	WORD xy[4], xyclip[4];

	xyclip[0] = parmblock->pb_xc;
	xyclip[1] = parmblock->pb_yc;
	xyclip[2] = parmblock->pb_xc + parmblock->pb_wc - 1;
	xyclip[3] = parmblock->pb_yc + parmblock->pb_hc - 1;
	vs_clip (v_handle, 1, xyclip);

	/* Objekt zeichnen */
	xy[0] = parmblock->pb_x;
	xy[1] = parmblock->pb_y;
	xy[2] = parmblock->pb_x + parmblock->pb_w - 1;
	xy[3] = parmblock->pb_y + parmblock->pb_h - 1;
	vsf_interior (v_handle, FIS_HOLLOW);
	v_rfbox (v_handle, xy);

	vs_clip (v_handle, 0, xy_clip);
	
	return (parmblock->pb_currstate);
}
MLOCAL VOID tune_dial (OBJECT *dial, WORD obj)	/* Objekt verndern je nach Objekttyp */
{
	WORD parent;

	switch ((dial[obj].ob_type & 0xFF00) >> 8)
	{
		case 101:			/* Objekt innerhalb des Parents zentrieren */
			if ((parent = GetParent (dial, obj)) != -1)
				dial[obj].ob_x = (dial[parent].ob_width - dial[obj].ob_width) / 2;
		break;
		
		case 102:			/* Objekt im Parent linksbndig */
			dia[obj].ob_x = 0;
		break;

		Case 103:			/* Objekt im Parent rechtsbndig */
			if ((parent = GetParent (dial, obj)) != -1)
				dial[obj].ob_x = dial[parent].ob_width - dial[obj].ob_width;
		break;

		case 110:			/* Linie einsetzen */
			dial[obj].ob_type         = G_USERDEF;
			dial[obj].ob_spec.userblk = &user_linie;
			user_line.ub_code         = uline;
		break;

		case 111:			/* Ankreuzbutton einsetzen */
			dial[obj].ob_type         = G_USERDEF;
			dial[obj].ob_spec.userblk = &user_select;
			user_line.ub_code         = uselbutton;
		break;

		case 112:			/* Rechteck mit abgerundeten Ecken einsetzen */
			dial[obj].ob_type         = G_USERDEF;
			dial[obj].ob_spec.userblk = &user_rrect;
			user_line.ub_code         = urrect;
		break;
	}
}

/* Hauptprogramm */
WORD main (VOID)
{
	/* Anmelden, ID abspeichern */
	if ((apl_id = appl_init()) != -1)
	{
		/* Resourcedatei laden */
		if (rsrc_load (rsrc_name) != 0)
		{
			/* Adresse unserer Dialogbox ermitteln */
			rsrc_gaddr (R_TREE, DEMODIAL, &demodial);

			TreeWalk (demodial, ROOT, tune_dial);	/* Extended Objects auswerten */
			v_handle = OpenWorkstation();	/* virtuelle Workstation ffnen */
			DoDialog (demodial);	/* Dialog durchfhren */
			CloseWorkstation (v_handle);	/* virtuelle Workstation schlieen */
			rsrc_free ();	/* Resourcedatei freigeben */
		}
		appl_exit();		/* abmelden */
		return (0);
	}
	else
		return (1);
}